import*as React from'react';import {useState,useEffect}from'react';import {useDispatch}from'react-redux';import {Subscription}from'rxjs';import {Modal,Spin}from'antd';import {useGetActivitiesByDayQuery}from'@admin-layout/activity-client';import {useGetOrganizationClientsQuery}from'@adminide-stack/account-api-client';import {useExtensionController}from'@adminide-stack/extension-module-browser';import {generateContributionId,CONTRIBUTION_ACTION_TYPES}from'@adminide-stack/extension-api';import {DailyDetailsTable,ProjectRecord,Activity,Duration,TimeRecord}from'./DailyDetailsTable.js';import*as _ from'lodash';const DailyDetailsModal = (props) => {
    const { selectedDay, visible, onClose, userId, projects } = props;
    const [contributions, setContributions] = useState({});
    const controller = useExtensionController();
    const subscriptions = new Subscription();
    const dispatch = useDispatch();
    const { data: clients, loading: loadClients } = useGetOrganizationClientsQuery();
    const { data, loading } = useGetActivitiesByDayQuery({
        variables: { userId, date: selectedDay === null || selectedDay === void 0 ? void 0 : selectedDay.format() },
        skip: !selectedDay
    });
    useEffect(() => {
        const id = generateContributionId();
        const contributionPoints = {
            contributions: {
                [id]: {
                    tables: {
                        'dailyDetails/table': [
                            { id: 'project', title: 'Project', accessor: 'project', width: 150, cell: ProjectRecord },
                            { id: 'activity', title: 'Activity', accessor: 'activity', width: 80, cell: Activity },
                            { id: 'duration', title: 'Duration', accessor: 'duration', width: 80, cell: Duration },
                            { id: 'time', title: 'Time', accessor: 'time', width: 130, cell: TimeRecord },
                        ],
                    },
                },
            },
        };
        // register contribution
        dispatch({
            type: CONTRIBUTION_ACTION_TYPES.REGISTER_CONTRIBUTIONS,
            payload: contributionPoints.contributions,
        });
        subscriptions.add(controller.services.contribution
            .getContributions()
            .subscribe(contribution => {
            setContributions(contribution);
        }));
        return function unsubscribe() {
            dispatch({
                type: CONTRIBUTION_ACTION_TYPES.DEREGISTER_CONTRIBUTIONS,
                payload: contributionPoints.contributions,
            });
            return subscriptions.unsubscribe();
        };
    }, []);
    return (React.createElement(Modal, { title: selectedDay === null || selectedDay === void 0 ? void 0 : selectedDay.format('ddd, MMM D, YYYY'), visible: visible, width: 700, onCancel: onClose, footer: false },
        React.createElement(Spin, { spinning: loading || loadClients },
            React.createElement(DailyDetailsTable, { contributions: contributions, data: _.get(data, 'getActivitiesByDay', []), dispatch: dispatch, projects: projects, clients: _.get(clients, 'getOrganizationClients', []) }))));
};export{DailyDetailsModal};//# sourceMappingURL=DailyDetailsModal.js.map
